/**
 * Filter.java
 *
 * File generated from the core::Filter uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class Filter.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Filter", propOrder = {
	"and",
	"or",
	"not",
	"equalityMatch",
	"substrings",
	"greaterOrEqual",
	"lessOrEqual",
	"present",
	"approxMatch",
	"extensibleMatch"
})
@XmlRootElement(name = "Filter")
public class Filter implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "and", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.FilterSet and;
	@XmlElement(name = "or", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.FilterSet or;
	@XmlElement(name = "not", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.Filter not;
	@XmlElement(name = "equalityMatch", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.AttributeValueAssertion equalityMatch;
	@XmlElement(name = "substrings", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.SubstringFilter substrings;
	@XmlElement(name = "greaterOrEqual", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.AttributeValueAssertion greaterOrEqual;
	@XmlElement(name = "lessOrEqual", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.AttributeValueAssertion lessOrEqual;
	@XmlElement(name = "present", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.AttributeDescription present;
	@XmlElement(name = "approxMatch", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.AttributeValueAssertion approxMatch;
	@XmlElement(name = "extensibleMatch", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.MatchingRuleAssertion extensibleMatch;

	public Filter(){
		super();
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return and.
	 * @return and
	 */
	public net.ihe.gazelle.hpd.FilterSet getAnd() {
	    return and;
	}
	
	/**
	 * Set a value to attribute and.
	 * @param and.
	 */
	public void setAnd(net.ihe.gazelle.hpd.FilterSet and) {
	    this.and = and;
	}
	
	
	
	
	/**
	 * Return or.
	 * @return or
	 */
	public net.ihe.gazelle.hpd.FilterSet getOr() {
	    return or;
	}
	
	/**
	 * Set a value to attribute or.
	 * @param or.
	 */
	public void setOr(net.ihe.gazelle.hpd.FilterSet or) {
	    this.or = or;
	}
	
	
	
	
	/**
	 * Return not.
	 * @return not
	 */
	public net.ihe.gazelle.hpd.Filter getNot() {
	    return not;
	}
	
	/**
	 * Set a value to attribute not.
	 * @param not.
	 */
	public void setNot(net.ihe.gazelle.hpd.Filter not) {
	    this.not = not;
	}
	
	
	
	
	/**
	 * Return equalityMatch.
	 * @return equalityMatch
	 */
	public net.ihe.gazelle.hpd.AttributeValueAssertion getEqualityMatch() {
	    return equalityMatch;
	}
	
	/**
	 * Set a value to attribute equalityMatch.
	 * @param equalityMatch.
	 */
	public void setEqualityMatch(net.ihe.gazelle.hpd.AttributeValueAssertion equalityMatch) {
	    this.equalityMatch = equalityMatch;
	}
	
	
	
	
	/**
	 * Return substrings.
	 * @return substrings
	 */
	public net.ihe.gazelle.hpd.SubstringFilter getSubstrings() {
	    return substrings;
	}
	
	/**
	 * Set a value to attribute substrings.
	 * @param substrings.
	 */
	public void setSubstrings(net.ihe.gazelle.hpd.SubstringFilter substrings) {
	    this.substrings = substrings;
	}
	
	
	
	
	/**
	 * Return greaterOrEqual.
	 * @return greaterOrEqual
	 */
	public net.ihe.gazelle.hpd.AttributeValueAssertion getGreaterOrEqual() {
	    return greaterOrEqual;
	}
	
	/**
	 * Set a value to attribute greaterOrEqual.
	 * @param greaterOrEqual.
	 */
	public void setGreaterOrEqual(net.ihe.gazelle.hpd.AttributeValueAssertion greaterOrEqual) {
	    this.greaterOrEqual = greaterOrEqual;
	}
	
	
	
	
	/**
	 * Return lessOrEqual.
	 * @return lessOrEqual
	 */
	public net.ihe.gazelle.hpd.AttributeValueAssertion getLessOrEqual() {
	    return lessOrEqual;
	}
	
	/**
	 * Set a value to attribute lessOrEqual.
	 * @param lessOrEqual.
	 */
	public void setLessOrEqual(net.ihe.gazelle.hpd.AttributeValueAssertion lessOrEqual) {
	    this.lessOrEqual = lessOrEqual;
	}
	
	
	
	
	/**
	 * Return present.
	 * @return present
	 */
	public net.ihe.gazelle.hpd.AttributeDescription getPresent() {
	    return present;
	}
	
	/**
	 * Set a value to attribute present.
	 * @param present.
	 */
	public void setPresent(net.ihe.gazelle.hpd.AttributeDescription present) {
	    this.present = present;
	}
	
	
	
	
	/**
	 * Return approxMatch.
	 * @return approxMatch
	 */
	public net.ihe.gazelle.hpd.AttributeValueAssertion getApproxMatch() {
	    return approxMatch;
	}
	
	/**
	 * Set a value to attribute approxMatch.
	 * @param approxMatch.
	 */
	public void setApproxMatch(net.ihe.gazelle.hpd.AttributeValueAssertion approxMatch) {
	    this.approxMatch = approxMatch;
	}
	
	
	
	
	/**
	 * Return extensibleMatch.
	 * @return extensibleMatch
	 */
	public net.ihe.gazelle.hpd.MatchingRuleAssertion getExtensibleMatch() {
	    return extensibleMatch;
	}
	
	/**
	 * Set a value to attribute extensibleMatch.
	 * @param extensibleMatch.
	 */
	public void setExtensibleMatch(net.ihe.gazelle.hpd.MatchingRuleAssertion extensibleMatch) {
	    this.extensibleMatch = extensibleMatch;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "Filter").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(Filter filter, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (filter != null){
   			cvm.validate(filter, _location, diagnostic);
			net.ihe.gazelle.hpd.FilterSet.validateByModule(filter.getAnd(), _location + "/and", cvm, diagnostic);
			net.ihe.gazelle.hpd.FilterSet.validateByModule(filter.getOr(), _location + "/or", cvm, diagnostic);
			net.ihe.gazelle.hpd.Filter.validateByModule(filter.getNot(), _location + "/not", cvm, diagnostic);
			net.ihe.gazelle.hpd.AttributeValueAssertion.validateByModule(filter.getEqualityMatch(), _location + "/equalityMatch", cvm, diagnostic);
			net.ihe.gazelle.hpd.SubstringFilter.validateByModule(filter.getSubstrings(), _location + "/substrings", cvm, diagnostic);
			net.ihe.gazelle.hpd.AttributeValueAssertion.validateByModule(filter.getGreaterOrEqual(), _location + "/greaterOrEqual", cvm, diagnostic);
			net.ihe.gazelle.hpd.AttributeValueAssertion.validateByModule(filter.getLessOrEqual(), _location + "/lessOrEqual", cvm, diagnostic);
			net.ihe.gazelle.hpd.AttributeDescription.validateByModule(filter.getPresent(), _location + "/present", cvm, diagnostic);
			net.ihe.gazelle.hpd.AttributeValueAssertion.validateByModule(filter.getApproxMatch(), _location + "/approxMatch", cvm, diagnostic);
			net.ihe.gazelle.hpd.MatchingRuleAssertion.validateByModule(filter.getExtensibleMatch(), _location + "/extensibleMatch", cvm, diagnostic);
    	}
    }

}